;==============================================================================================================
;===Get Char===================================================================================================
;--------------------------------------------------------------------------------------------------------------
;Finds pixel color pattern of specific X and Y values, returns char if pixel color pattern found.
;--------------------------------------------------------------------------------------------------------------

Func getChar(ByRef $x, $y)
	Local $charWidth[54] = [2, 2, 2, 2, 2, 3,			_	;{space} i l I , j ; hardest cases
							7,5, 7,6, 6,5, 6,6, 6,6,	_	;Aa Bb Cc Dd Ee
							5,5, 6,5, 8,6, 6,			_	;Ff Gg Hh J
							7,5, 4,   10,10, 7,6, 6,6,	_	;Kk L  Mm Nn Oo
							6,5, 7,6, 7,5, 7,6, 6,6,	_	;Pp Qq Rr Ss Tt
							7,6, 7,5, 11,9, 7,6, 7,6,	_	;Uu Vv Ww Xx Yy
							7,4]							;Zz

	Local $charString[54] = [" ", "i", "l", "I", ",", "j", _
							"A", "a", "B", "b", "C", "c", "D", "d", "E", "e", _
							"F", "f", "G", "g", "H", "h", "J", _
							"K", "k", "L", "M", "m", "N", "n", "O", "o", _
							"P", "p", "Q", "q", "R", "r", "S", "s", "T", "t", _
							"U", "u", "V", "v", "W", "w", "X", "x", "Y", "y", _
							"Z", "z"]

	Local $charOffset[54][3][2] = _
[[[1,3], [1,7], [2,5]], [[1,1], [1,2], [1,8]], [[1,2], [0,2], [1,7]], [[1,2], [2,5], [1,8]], [[1,7], [1,8], [1,9]], [[1,0], [1,4], [1,9]],	_	;{space} i l I , j
 [[1,8], [5,7], [6,8]], [[5,3], [1,4], [4,7]], [[6,1], [1,1], [3,4]], [[3,4], [4,7], [1,1]], [[1,1], [2,2], [5,3]], [[3,2], [5,8], [4,4]],	_ 	;Aa Bb Cc
 [[3,7], [6,1], [2,3]], [[3,4], [4,7], [1,3]], [[2,6], [2,2], [3,0]], [[1,2], [2,3], [4,6]], [[3,2], [1,8], [5,1]], [[5,1], [2,4], [2,8]],	_	;Dd Ee Ff
 [[4,4], [3,0], [4,5]], [[1,9], [4,8], [4,4]], [[5,8], [3,3], [1,1]], [[2,5], [3,4], [5,3]], 												_	;Gg Hh
 [[1,5], [4,7], [6,1]], [[2,3], [3,6], [6,0]], [[1,1], [2,1], [4,8]], [[2,7], [4,7], [1,0]], 												_	;J Kk L
 [[4,8], [6,1], [8,8]], [[1,8], [7,2], [5,4]], [[3,1], [5,4], [6,1]], [[5,3], [4,8], [2,5]], [[2,6], [2,0], [5,6]], [[2,4], [4,5], [3,2]],	_	;Mm Nn Oo
 [[4,2], [2,8], [5,3]], [[2,4], [1,10],[5,3]], [[4,9], [2,2], [6,4]], [[3,4], [4,8], [4,10]],[[4,2], [3,6], [6,1]], [[4,5], [2,6], [2,2]],	_	;Pp Qq Rr
 [[2,0], [5,4], [3,7]], [[2,2], [4,4], [2,7]], [[1,0], [4,2], [2,8]], [[2,1], [1,8], [4,6]], [[1,1], [1,8], [5,1]], [[2,3], [2,7], [4,3]],	_	;Ss Tt Uu
 [[2,2], [3,5], [5,7]], [[2,3], [3,6], [5,3]], [[2,3], [6,1], [9,8]], [[3,5], [5,7], [8,8]], [[1,2], [3,7], [5,4]], [[1,4], [2,8], [5,6]],	_	;Vv Ww Xx
 [[2,1], [5,5], [3,8]], [[1,8], [3,7], [3,10]],[[2,2], [1,7], [5,7]], [[1,4], [3,5], [2,8]]]													;Yy Zz

	Local $charColor[54][3] = _
[[0x3F4440,0x3F4440,0x3F4440],[0xF0F1F0,0x454945,0xE1E1E1],[0xFEFEFE,0x909290,0xFEFEFE],[0xFEFEFE,0xA3A5A3,0xE1E1E1],[0xE8E8E8,0xFEFEFE,0xA5A7A5],[0x9FA2A0,0xFDFEFD,0xFDFEFD], _	;{space} i l I , j
 [0xE7E7E7,0xDBDCDB,0xD5D6D5],[0xACAEAC,0xC2C3C2,0xDADBDA],[0xE2E3E2,0xFBFBFA,0xE8E9E8],[0x8D8F8D,0xCACBCA,0xFBFBFB],[0xE8E8E8,0xC9CAC9,0xDBDBDB],[0x818481,0x949694,0xECEDEC], _	;Aa Bb Cc
 [0xACAEAC,0xA0A2A0,0xB6B8B6],[0x8D8F8D,0xE4E5E4,0xABADAB],[0xA5A7A5,0xC3C5C3,0x767976],[0x404440,0xF5F5F5,0x7B7D7B],[0x515451,0xE1E1E1,0xC6C7C6],[0xC4C5C4,0xBFC0BF,0x535653], _	;Dd Ee Ff
 [0x707370,0xC4C5C4,0xD1D2D1],[0xD7D8D7,0xE6E7E6,0xE7E7E7],[0x5F635F,0x464A46,0xFAFAFA],[0x818481,0xD3D4D3,0x646764],															_	;Gg Hh
 [0x8E908E,0xC4C5C4,0xFBFBFB],[0xCFD0CF,0x828482,0x7C7E7C],[0xFBFBFB,0x646764,0xDBDCDB],[0xFDFDFD,0x828482,0x646764],															_	;J Kk L
 [0x8C8E8C,0x6A6D6A,0xA9ABA9],[0xD5D6D5,0x585C58,0xFFFFFF],[0x949694,0x707370,0xBFC0BF],[0xBEC0BE,0x8A8D8A,0x7A7D7A],[0xBBBDBB,0x888A88,0xD9DAD9],[0x888A88,0xA9ABA9,0x585C58], _	;Mm Nn Oo
 [0x636663,0x858785,0xE6E7E6],[0x8D908D,0xFFFFFF,0x898B89],[0xE6E7E6,0xABADAB,0xFFFFFF],[0x696C69,0xFFFFFF,0xC1C2C1],[0x575A57,0x939593,0xB8BAB8],[0x747774,0x5F635F,0x464A46], _	;Pp Qq Rr
 [0x8E908E,0x9C9E9C,0x7C7F7C],[0x707370,0xC3C4C3,0x909290],[0x707370,0xB7B8B7,0x969896],[0x767976,0xB6B8B6,0xA6A8A6],[0xFBFBFB,0x626562,0xBFC0BF],[0x525652,0xCBCCCB,0x888A88], _	;Ss Tt Uu
 [0x898C89,0x707370,0xE1E2E1],[0x595C59,0x525652,0xEEEEEE],[0xAEB0AE,0xC5C6C5,0x989A98],[0x8E918E,0x747674,0x797C79],[0x989B98,0x939593,0xB6B8B6],[0x8C8E8C,0x9EA09E,0x4C4F4C], _	;Vv Ww Xx
 [0xA1A3A1,0x8C8E8C,0xD5D6D5],[0x5D615D,0xEEEEEE,0xE8E9E8],[0x505450,0x707370,0x888B88],[0x757775,0x757875,0xDADBDA]]																;Yy Zz

	For $i = 0 to 53
		For $z = -1 to 2
			Local $pixel1[3] = [$x + $z + $charOffset[$i][0][0], $y + $charOffset[$i][0][1], Hex($charColor[$i][0], 6)]
			Local $pixel2[3] = [$x + $z + $charOffset[$i][1][0], $y + $charOffset[$i][1][1], Hex($charColor[$i][1], 6)]
			Local $pixel3[3] = [$x + $z + $charOffset[$i][2][0], $y + $charOffset[$i][2][1], Hex($charColor[$i][2], 6)]
			If boolPixelSearch($pixel1, $pixel2, $pixel3, 1) Then
				$x += $z + $charWidth[$i]
				Return $charString[$i]
			EndIf
		Next
	Next

	$x += 4
	Return "|"
EndFunc